Storage/Models/ErrorViewModel.cs
using System;

namespace Storage.Models
{
    public class ErrorViewModel
    {
        public string RequestId { get; set; }

        public bool ShowRequestId => !string.IsNullOrEmpty(RequestId);
    }
}

Storage/Models/IndexModel.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Storage.Models
{
    public class IndexModel
    {
        public List<RecordModel> RecordList { get; set; }
    }
}

Storage/Models/RepositoryModel.cs
using System;
using System.Collections.Concurrent;
using System.ComponentModel.DataAnnotations;

namespace Storage.Models
{
    public class RepositoryModel
    {
        public ConcurrentDictionary<string, RecordModel> Storage { get; } = new ConcurrentDictionary<string, RecordModel>();
        public RepositoryModel()
        {
            Storage["1"] = new RecordModel { Key = "1", Value = "2", ChangeDate = DateTime.Now.AddSeconds(20), CreateDate = DateTime.Now };
            Storage["sadsa"] = new RecordModel { Key = "sadsa", ChangeDate = DateTime.Now.AddSeconds(50), CreateDate = DateTime.Now };
            
        }
    }

    public class RecordModel
    {
        [Required(ErrorMessage = "Введите значение ключа")]
        [Display(Name = "Ключ")]
        public string Key { get; set; }

        [Display(Name = "Значение")]
        public string Value { get; set; }

        
        [Display(Name = "Количество обращений")]
        public long CountRequest { get; set; }

        [Display(Name = "Дата создания записи")]
        public DateTime CreateDate { get; set; }

        [Display(Name = "Дата редактирования записи")]
        public DateTime ChangeDate { get; set; }
    }
}

Storage/Controllers/HomeController.cs
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Storage.Models;

namespace Storage.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult About()
        {
            ViewData["Message"] = "Your application description page.";

            return View();
        }

        public IActionResult Contact()
        {
            ViewData["Message"] = "Your contact page.";

            return View();
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}

Storage/Controllers/StorageInfoController.cs
using System;
using System.Collections.Concurrent;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Storage.Models;

namespace Storage.Controllers
{
    public class StorageInfoController : Controller
    {
        private readonly RepositoryModel _info;

        public StorageInfoController(RepositoryModel info)
        {
            _info = info;

        }
        public IActionResult Index()
        {
            return View(new IndexModel { RecordList = _info.Storage.Values.ToList() });
        }

        [HttpPost]
        public IActionResult Delete(string key, RecordModel value)
        {
            _info.Storage.TryRemove(key, out value);
            if (_info.Storage != null)
            {
                TempData["message"] = $"удалена запись c ключем {key} и значением {value}";
            }
            return RedirectToAction("Index");
        }

        [HttpGet]
        public ViewResult Edit(string key, DateTime createDate)
        {
            if (string.IsNullOrWhiteSpace( key))
            {
                return View(new RecordModel { CreateDate = DateTime.Now });
            }

            RecordModel record = _info.Storage.AddOrUpdate(
                key,
                (RecordModel)null,
                (k, v) => { ++v.CountRequest;  v.CreateDate = createDate; return v; });

            return View("Edit",record);
        }


        [HttpPost]
        public IActionResult Edit(RecordModel model)
        {
            if (ModelState.IsValid)
            {
                model.ChangeDate = DateTime.Now;

                

                _info.Storage.AddOrUpdate(model.Key, model, (k, v) => { model.CountRequest = v.CountRequest; model.CreateDate = v.CreateDate; return model; });

                if (_info.Storage != null)
                {
                    if (model.CreateDate == DateTime.MinValue)
                    {
                        model.CreateDate = DateTime.Now;
                    }
                    TempData["message"] = $"отредактирована запись c ключем {model.Key} и значением {model.Value} ";
                }

           

                return RedirectToAction("Index");
            }
            else
            {
                //Что-то не так со значениями данных
                return View();
            }
        }

        [HttpGet]
        public IActionResult ShowNotEmptyValue()
        {
            return View("Index", new IndexModel
            {
                RecordList = _info.Storage.Values.Where(p => !string.IsNullOrWhiteSpace(p.Value)).ToList()
            });
        }

        [HttpGet]
        public IActionResult ClearRecords()
        {
            _info.Storage.Clear();
            return View("Index", new IndexModel
            {
                RecordList = _info.Storage.Values.ToList()
            });
          
        }
    }



    //static class ExtensionMethods
    //{
    //    // Добавление или Обновление записи
    //    public static void AddOrUpdate<K, V>(this ConcurrentDictionary<K, V> dictionary, K key, V value)
    //    {
    //        dictionary.AddOrUpdate(key, value, (oldkey, oldvalue) => value);
    //    }
    //}
}

Storage/Views/Shared/_Favicons.cshtml
<link rel="shortcut icon" type="image/x-icon" href="~/favicon/favicon.ico">

Storage/Views/Shared/_Layout.cshtml
<!DocType html>


<html>

<head>
    <meta name="viewport" content="width=device-width" />
    @await Html.PartialAsync("_Favicons")

    <link rel="stylesheet" asp-href-include="~/bootstrap/bootstrap/dist/css/*min.css" />
    <link rel="stylesheet" asp-href-include="~/font-awesome/css/font-awesome.min.css" />
    <script asp-src-include="~/jquery/dist/jquery.min.js"></script>
    <script asp-src-include="~/jquery-validation/dist/jquery.validate.js"></script>
    <script asp-src-include="~/jquery-validation-unobtrusive/dist/jquery.validate.unobtrusive.js"></script>
    <title>SportsStore</title>
</head>

<body>
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm-12">
                <nav>
                    <div class="navbar navbar-inverse" role="navigation">
                        <ul class="nav navbar-nav top-right">
                            <li><a asp-area="" asp-controller="StorageInfo" asp-action="Index">Хранилище данных</a></li>
                            <li><a asp-area="" asp-controller="Home" asp-action="Index">Home</a></li>
                            <li><a asp-area="" asp-controller="Home" asp-action="About">About</a></li>
                            <li><a asp-area="" asp-controller="Home" asp-action="Contact">Contact</a></li>
                        </ul>
                    </div>
                </nav>
            </div>
        </div>

        @RenderBody()

    </div>
   

    

</body>

</html>

Storage/Views/StorageInfo/Edit.cshtml
@model RecordModel

@{
    ViewData["Title"] = "Редактирование продукта";
    Layout = "_Layout";
}



<div asp-validation-summary="All" class="text-danger"></div>
<form asp-action="Edit" asp-controller="StorageInfo"  method="post">
    <div class="form-group">
        <label asp-for="Key" class="control-label"></label>
        <div>
            <span asp-validation-for="Key" class="text-danger"></span>
        </div>
        <input asp-for="Key" class="form-control" value="@Model.Key" />
    </div>
    <div class="form-group">
        <label asp-for="Value" class="control-label"></label>
        <div>
            <span asp-validation-for="Value" class="text-danger"></span>
        </div>
        <input asp-for="Value" class="form-control" value="@Model.Value" />
    </div>

    <div class="form-group ">
        <label asp-for="ChangeDate" class="control-label"></label>        
        <span class="form-control">@Model.ChangeDate</span>
        
    </div>

    <div class="form-group ">
        <label  asp-for="CreateDate" class="control-label"></label>         
        <span   class="form-control" value="@Model.CreateDate">@Model.CreateDate</span>
        <input asp-for="@Model.CreateDate" type="hidden" />
    </div>

    <div class="form-group ">
        <label asp-for="CountRequest" class="control-label"></label>
        <span class="form-control">@Model.CountRequest</span>
    </div>

    <div class="text-center">
        <button type="submit" class="btn btn-primary">Сохранить</button>
        <a asp-action="Index" class="btn btn-default">Отменить</a>
    </div>

</form>


<div>
    <a asp-action="Index">Вернуться назад</a>
</div>

Storage/Views/StorageInfo/Index.cshtml
@model IndexModel

@{
    Layout = "_Layout";
}

@if ( Model.RecordList.Count() != 0  )
{
    <div class="row">

        <div class="col-sm-12">
            @if (TempData["message"] != null)
            {
                <div class="alert-success">
                    <h4>@TempData["message"]</h4>
                </div>
            }
            <table class="table table-bordered table-striped">
                <tr>
                    <th class="text-center">Ключ</th>
                    <th class="text-center">Значение</th>
                    <th class="text-center">Дата создания</th>
                </tr>
                <tbody>
                    @foreach (var record in Model.RecordList)
                    {
                        <tr>
                            <td class="text-center">@record.Key</td>
                            <td class="text-center">@record.Value</td>
                            <td class="text-center">@record.CreateDate</td>
                            <td class="text-center">
                                <form asp-action="Delete" asp-controller="StorageInfo" method="get">
                                    <a asp-action="Edit" class="btn btn-sm btn-warning"
                                       asp-route-Key="@record.Key" asp-route-CreateDate="@record.CreateDate">
                                        Редактировать запись
                                    </a>
                                    <input type="hidden" name="Key" value="@record.Key" />
                                    <input type="hidden" name="Value" value="@record.Value" />
                                    <button type="submit" class="btn btn-danger btn-sm">
                                        Удалить Запись
                                    </button>
                                </form>
                            </td>
                        </tr>
                    }
                </tbody>
            </table>
            <a asp-action="ShowNotEmptyValue" class="btn btn-sm btn-success ">
                Показать записи у которых есть значения
            </a>

            <a asp-action="ClearRecords" class="btn btn-sm btn-success ">
                Удалить все записи
            </a>

            <a asp-action="Edit" class="btn btn-sm btn-success pull-right">
                Добавить запись
            </a>
        </div>
    </div>
}
else
{
    <div class="row">
        <div class="col-sm-12">
            <div>
                <form asp-action="Edit" method="post">
                    <a asp-action="Edit" class="btn btn-sm btn-success pull-right">
                        Добавить новую запись
                    </a>
                </form>
            </div>
        </div>
    </div>

}